package cscie259.project3.wahoo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;


/**
 * This class gets news headlines by connecting to Moreover.
 *
 * You MAY modify this file.
 *
 * @author  Computer Science E-259
 * @version 6.0
 *
 * @author  YOUR NAME GOES HERE
 **/

public final class NewsProvider
{
    /**
     * Default constructor is private so that this utility
     * class cannot be instantiated.
     */
    private NewsProvider() {}


    /**
     * Returns an XML representation of the headlines for a given
     * category.
     *
     * @param category category for which to fetch headlines
     *
     * @return XML representation of headlines for given category
     *
     * @throws IOException if an IO-related error occurs
     */
    public static String getHeadlines(String category)
    throws IOException
    {
        // retrieve newsfeed from Moreover, taking care to escape URL
        // to the application/x-www-form-urlencoded MIME format
        System.out.println("Getting category = " + category);
        String urlStr = "http://p.moreover.com/cgi-local/page?c=" +
                        java.net.URLEncoder.encode(category, "UTF-8") +
                        "&o=xml";
        java.net.URL url = new java.net.URL(urlStr);
        InputStream in = url.openStream();
        BufferedReader reader = new BufferedReader(new InputStreamReader(in));
        String line;
        String xmlStr = "";
        boolean start = false;

        // iterate through retrieved XML in order to grab root element
        // and its descendants
        do
        {
            line = reader.readLine();
            if (line != null)
            {
                // This is a trick to eliminate the <?xml?> declaration and
                // the DOCTYPE declaration in order that this be a legal
                // XML fragment that can be embedded into another document!
                if (line.indexOf("<moreovernews>") != -1)
                    start = true;
                if (start)
                    xmlStr += line + "\n";
            }
        }
        while (line != null);

        // return root element and its descendants as a String
        return xmlStr;
    }

}
