package cscie259.project3.wahoo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * This servlet displays personalized preferences in the Wahoo portal.
 *
 * You MUST modify this file.
 *
 * @author  Computer Science E-259
 * @version 6.0
 *
 * @author  YOUR NAME GOES HERE
 **/

public class Prefs extends WahooServlet
{
    /**
     * a cached copy of the categories XML file
     */
    private String categoriesXML_ = "";


    /**
     * Called automatically by servlet container; initializes the servlet 
     * and the categories list.
     *
     * @throws ServletException if a servlet-related error occurs
     */
    public void init()
    throws ServletException
    {
        // ensure UserManager is instantiated
        super.init();
    
        // try to read categories into memory
        try
        {
            // grab categories from cached file
            ServletContext context = getServletContext();
            InputStream in 
             = context.getResourceAsStream("/xml/cache/nested_category_list.xml");
            BufferedReader reader =
             new BufferedReader(new InputStreamReader(in));
            String line;
            boolean start = false;

            // iterate through XML in order to grab root element
            // and its descendants
            do
            {
                line = reader.readLine();
                if (line != null)
                {
                    // This is a trick to eliminate the <?xml?> declaration and
                    // the DOCTYPE declaration in order that this be a legal
                    // XML fragment that can be embedded into another document!
                    if (line.indexOf("<nested_category_list>") != -1)
                        start = true;
                    if (start)
                        categoriesXML_ += line + "\n";
                }
            }
            while (line != null);
        }

        // catch any error
        catch (IOException e)
        {
            throw new ServletException("Can't read categories: " +
                                       e.getMessage());
        }
    }


    /**
     * Displays and processes the preferences form; if user attempts to execute
     * this servlet before user's authenticated (via the login
     * servlet), should redirect user to login servlet.
     *
     * @param request  HTTP request object
     * @param response HTTP response object
     *
     * @throws IOException      if an IO-related error occurs
     * @throws ServletException if a servlet-related error occurs
     */
    public void doWork(HttpServletRequest request,
                       HttpServletResponse response)
    throws IOException, ServletException
    {
        // TODO
    }
}
