package cscie259.project3.wahoo;

import java.util.LinkedList;
import java.util.List;


/**
 * This class represents a single user of the Wahoo portal.
 *
 * You MAY modify this file.
 *
 * @author  Computer Science E-259
 * @version 6.0
 *
 * @author  YOUR NAME GOES HERE
 **/

public class User
{
    /*
     * user's username
     */
    private String username_;


    /*
     * user's password
     */
     private String password_;


    /*
     * user's list of preferred categories
     */
     private List newsCategories_ = new LinkedList();


    /**
     * Creates a new User object, recording user's name and a password.
     *
     * @param username new user's username
     * @param password new user's password
     */
    public User(String username, String password)
    {
        username_ = username;
        password_ = password;
    }


    /**
     * Add a news category to the preferred list, if it not already in the
     * list.
     *
     * @param cat category to be added to user's preferred categories
     */
    public void addNewsCategory(String cat)
    {
        if (!newsCategories_.contains(cat))
            newsCategories_.add(cat);
    }


    /**
     * Get the user's preferred news categories.
     *
     * @return list of user's preferred news categories
     */
    public List getNewsCategories()
    {
        return newsCategories_;
    }


    /**
     * Get the password for this user.
     *
     * @return user's password
     */
    public String getPassword()
    {
        return password_;
    }


    /**
     * Get the username for this user.
     *
     * @return user's username
     */
    public String getUserName()
    {
        return username_;
    }


    /**
     * Removes a news category to the preferred list if it is on the list.
     *
     * @param cat category to be removed from user's preferred categories
     */
    public void removeNewsCategory(String cat)
    {
        newsCategories_.remove(cat);
    }


    /**
     * Saves the user's preferred news categories, overwriting previous
     * settings.
     *
     * @param newsCategories list of user's preferred news categories
     */
    public void setNewsCategories(List newsCategories)
    {
        newsCategories_ = newsCategories;
    }
}
