package cscie259.project3.wahoo;

import java.io.IOException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;


/**
 * Base class for Wahoo's servlets.
 *
 * You MAY modify this file.
 *
 * @author  Computer Science E-259
 * @version 6.0
 *
 * @author  YOUR NAME GOES HERE
 **/

public abstract class WahooServlet extends HttpServlet
{
    /**
     * Common initialization tasks for this group of servlets.
     * Initializes the UserManager instance.
     *
     * @throws ServletException if a servlet-related error occurs
     */
    public void init()
    throws ServletException
    {
        UserManager.init(getServletContext());
    }


    /**
     * Responds to GETs in the same manner as POSTs.
     *
     * @param request HTTP request object
     * @param response HTTP response object
     *
     * @throws IOException      if an IO-related error occurs
     * @throws ServletException if a servlet-related error occurs
     */
    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
    throws IOException, ServletException
    {
        doWork(request, response);
    }


    /**
     * Responds to POSTs in the same manner as GETs.
     *
     * @param request HTTP request object
     * @param response HTTP response object
     *
     * @throws IOException      if an IO-related error occurs
     * @throws ServletException if a servlet-related error occurs
     */
    public void doPost(HttpServletRequest request,
                       HttpServletResponse response)
    throws IOException, ServletException
    {
        doWork(request, response);
    }


    /**
     * To be implemented by descendants, handles GETs and POSTs identically.
     *
     * @param request HTTP request object
     * @param response HTTP response object
     *
     * @throws IOException      if an IO-related error occurs
     * @throws ServletException if a servlet-related error occurs
     */
    protected abstract void doWork(HttpServletRequest request,
                                   HttpServletResponse response)
    throws IOException, ServletException;


    /**
     * Used to forward the request and response objects to another servlet
     * (whose path is of the form "/servlet/foo") for processing.
     *
     * @param request   HTTP request object
     * @param response  HTTP response object
     * @param path      the path to the servlet being forwarded to
     *
     * @throws IOException      if an IO-related error occurs
     * @throws ServletException if a servlet-related error occurs
     */
    public void forward(HttpServletRequest request,
                               HttpServletResponse response,
                               String path)
    throws IOException, ServletException
    {
        RequestDispatcher dispatch =
         request.getRequestDispatcher(path);
        dispatch.forward(request, response);
    }


    /**
     * Used to redirect the user to another url (or servlet in the
     * same container), without preserving the current
     * HttpServletRequest object.
     *
     * @param response  HTTP response object
     * @param url      the url to which the user's being redirected
     *
     * @throws IOException      if an IO-related error occurs
     */
    public void redirect(HttpServletResponse response, String url)
    throws IOException
    {
        response.sendRedirect(url);
    }
}
