<?xml version="1.0" encoding="UTF-8"?>

<!-- XSLT stylesheet for Wahoo!'s login page -->
<xsl:stylesheet exclude-result-prefixes="xalan" version="1.0" xmlns="http://www.w3.org/1999/xhtml" xmlns:xalan="http://xml.apache.org/xslt" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- an optional error string -->
  <xsl:param name="error" select="''"/>

  <!-- output pretty-printed results as XHTML 1.0 -->
  <xsl:output doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" encoding="UTF-8" indent="yes" method="xml" xalan:indent-amount="4"/>

  <xsl:template match="/">
    <html xml:lang="en" lang="en">
      <head>
        <title>Wahoo!</title>
      </head>
      <body onLoad="document.form.username.focus()">
        <center>
          <img src="/images/wahoo.gif" alt="Wahoo!"/>
          <p/>
          <form action="/servlet/login" method="POST" name="form">
            <table>
              <tr>
                <td width="40%">
                  <strong>Login:</strong>
                </td>
                <td width="60%">
                  <input type="text" name="username" value="" size="19" />
                </td>
              </tr>
              <tr>
                <td>
                  <strong>Password:</strong>
                </td>
                <td>
                  <input type="password" name="password" value="" size="19" />
                </td>
              </tr>
              <xsl:if test="$error">
                <tr>
                  <td colspan="2" align="center">
                    <strong style="color:red">
                      <xsl:value-of select="$error"/>
                    </strong>
                  </td>
                </tr>
              </xsl:if>
              <tr>
                <td colspan="2" align="center">
                  <input name="submit" type="submit" value="Log In" />&#160;&#160;<input name="submit" type="submit" value="Register" />
                </td>
              </tr>
            </table>
          </form>
        </center>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
